/*
 * Definition of NQueens general problem object
 */

package edu.umn.d.cs5541.GraphProblem.NQueens;

import edu.umn.d.cs5541.GraphProblem.Problem;
import edu.umn.d.cs5541.GraphProblem.ProblemState;

/**
 *
 * @author rmaclin
 */
public class NQueensProblem implements Problem {
    /**
     * Size of N Queens problem (how many queens)
     */
    public int N = 0;

    /**
     * Create an initial N Queens problem reading command line arguments to
     * potentially set the number of queens
     * @param args are the input arguments to the routine (should be passed
     * from main)
     * @throws Throwable
     */
    public NQueensProblem(String[] args) throws Throwable {
        if (args.length == 0) {
            N = 4;
        } else if (args.length == 1) {
            N = Integer.parseInt(args[0]);
        } else {
            throw new Throwable("NQueens takes 0 or 1 argument!\n");
        }
    }

    /**
     * Routine to produce the startState for an NQueens problem
     * @return
     * @throws Throwable
     */
    public ProblemState startState() throws Throwable {
        return (ProblemState) (new NQueensProblemState(N));
    }


    /**
     * Calculate actual cost of going from state to state
     * @param state1
     * @param state2
     * @return
     */
    public double stateToStateCost(ProblemState state1, ProblemState state2) {
        return 1;
    }

    /**
     * Estimate cost of going from state to the goal
     * @param state
     * @return
     */
    public double costToGoal(ProblemState state) {
        return (N - ((NQueensProblemState) state).numColumnsSet);
    }
}
